'use strict';

exports.__esModule = true;
exports.default = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var $ = typeof $ === 'undefined' ? require('jquery') : $;

var Main = function (_Component) {
  _inherits(Main, _Component);

  function Main(props) {
    _classCallCheck(this, Main);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    var sets = props.sets || {};
    _this.state = {
      num: '-',
      start: sets.start,
      end: sets.end
    };
    return _this;
  }

  Main.prototype.componentDidMount = function componentDidMount() {
    this.animate();
  };

  Main.prototype.componentWillReceiveProps = function componentWillReceiveProps(newprop) {
    var _this2 = this;

    if (newprop.sets.end === this.state.end) return;
    this.setState(function (prevState) {
      return {
        end: newprop.sets.end
      };
    }, function () {
      return _this2.animate();
    });
  };

  Main.prototype.format_number = function format_number(n) {
    var zhengshu = n >= 0;
    var b = Math.abs(~~n).toString();
    var len = b.length;
    if (len <= 3) {
      return ~~n;
    }
    var r = len % 3;
    var result = b.slice(0, r) + "," + b.slice(r, len).match(/\d{3}/g).join(",");
    if (result.startsWith(',')) {
      result = result.substring(1);
    }
    return zhengshu ? result : '-' + result;
  };

  Main.prototype.animate = function animate() {
    var _this3 = this;

    var sets = this.props.sets || {};
    var _sets$duration = sets.duration,
        duration = _sets$duration === undefined ? 1000 : _sets$duration,
        _sets$easing = sets.easing,
        easing = _sets$easing === undefined ? 'swing' : _sets$easing,
        _sets$format = sets.format,
        format = _sets$format === undefined ? false : _sets$format;

    var start = this.state.start || 0;
    var end = this.state.end === 0 ? 0 : this.state.end || start;
    $(this).attr('nums', start).animate({
      nums: end
    }, {
      duration: duration,
      easing: easing,
      step: function step(re) {
        // const nu = Math.ceil(re);
        var nu = re.toFixed(sets.dot || 0);
        var num = format ? _this3.format_number(nu) : nu;

        // if(format&&sets.dot){
        //   console.log(re.toFixed(sets.dot),sets.dot)
        //   num = (+(re.toFixed(sets.dot))).toLocaleString()
        // }
        _this3.setState({ start: re, num: num });
      }
    });
  };

  Main.prototype.render = function render() {
    return _react2.default.createElement(
      'span',
      { id: this.props.id, className: this.props.className },
      this.state.num
    );
  };

  return Main;
}(_react.Component);

exports.default = Main;


_react.Component.propTypes = {
  sets: _propTypes2.default.shape({
    start: _propTypes2.default.number,
    duration: _propTypes2.default.number,
    end: _propTypes2.default.number,
    easing: _propTypes2.default.oneOf(['easing', 'linear']),
    format: _propTypes2.default.bool,
    dot: _propTypes2.default.number
  }),
  className: _propTypes2.default.string
};
module.exports = exports['default'];